/*-------------------------------------------------------------------------
 Hash function SHA256

 File name   : SHA256_TB.v
 Version     : Version 0.1
 Created     : JUN/09/2007
 Last update : JUN/09/2007
 Desgined by : Akashi Satoh
 
 
 Copyright (C) 2007 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://www.rcis.aist.go.jp/special/SASEBO/index-en.html).
 -------------------------------------------------------------------------*/

`timescale 1ns/1ns

module SHA256_TEST;

parameter CLOCK = 10;

reg  [31:0] MSG;
reg  Mrdy;
reg  clk;
reg  en;
reg  rst;
wire [31:0] Hout;
wire Hvld;

reg  [31:0] W[0:15];

SHA256 C2(MSG, Mrdy, clk, en, rst, Hout, Hvld); 

initial W[ 0] = 32'h61626380;
initial W[ 1] = 32'h00000000;
initial W[ 2] = 32'h00000000;
initial W[ 3] = 32'h00000000;
initial W[ 4] = 32'h00000000;
initial W[ 5] = 32'h00000000;
initial W[ 6] = 32'h00000000;
initial W[ 7] = 32'h00000000;
initial W[ 8] = 32'h00000000;
initial W[ 9] = 32'h00000000;
initial W[10] = 32'h00000000;
initial W[11] = 32'h00000000;
initial W[12] = 32'h00000000;
initial W[13] = 32'h00000000;
initial W[14] = 32'h00000000;
initial W[15] = 32'h00000018;

initial clk  = 0;
always #(CLOCK/2)
  clk <= ~clk;

initial begin

#(CLOCK/5)


// Data Initialize and Sequencer Reset

  en   <= 1;
  Mrdy <= 0;
  rst  <= 1;
#(CLOCK)
  rst  <= 0;
#(CLOCK*10)

// 1st 32-bit*16 block
  Mrdy <= 1;
  MSG  <= W[0];
#(CLOCK)
  MSG  <= W[1];
  Mrdy <= 0;
#(CLOCK)
  Mrdy <= 1;
#(CLOCK*14)
  MSG  <= W[15];
#(CLOCK)
  Mrdy <= 0;
#(CLOCK*56)
#(CLOCK*14)

// 2nd 32-bit*16 block
  Mrdy <= 1;
  MSG  <= W[0];
#(CLOCK)
  MSG  <= W[15];
  Mrdy <= 0;
#(CLOCK)
  Mrdy <= 1;
#(CLOCK*15)
  MSG  <= W[15];
#(CLOCK)
  Mrdy <= 0;
#(CLOCK*60)
$stop;
end

endmodule